Subject: Re: 'git log' numbering commits?

From: Daniel Wagner <[email-masked]>
Date: Thu, 12 Apr 2012 11:15:56 +0200

Hi Jeff,

On 12.04.2012 10:41, Jeff King wrote:
> On Thu, Apr 12, 2012 at 09:54:12AM +0200, Daniel Wagner wrote:
> 
>> My workflow involves a lot of "git rebase -i". For figuring out which
>> commit id to use I do first a 'git log --oneline'. Then I do copy past
>> the id to the 'git rebase -i'. The reason why I don't use relative
>> id such as HEAD~4, because I keep miscounting the commits.
>>
>> So my question is there a magic option to have git log to enumerate the
>> commits, e.g.
>>
>> 1: 2fcd2b3 network: Remove unused function
>> 2: b376b2a session: Fix introspection for Change()
>> 3: 15c9cd0 wifi: Refactor desctruction of network object
>> 4: a9c699f network: Remove device pointer in network_remove()
> 
> No, there is no such feature. You can do this:
> 
>   git log --oneline | nl "-s: "

Obviously, I tend to forget the power of the pipes :)

> but that will just give you the count of commits shown. If the history
> is not a single line of development, then those numbers will become
> meaningless quickly. Also note that there is an off-by-one in this
> scheme; HEAD~2 will be numbered as "3".
> 
> If you wanted to simply decorate each commit with a more readable name,
> you could do this:
> 
>   git log --format='%H: %s' |
>   git name-rev --stdin --name-only
> 
> though for simplicity, you may find that you prefer to name only based on
> the current tip. You can do that like this:
> 
>   git log --format='%H: %s' |
>   git name-rev --stdin --name-only \
>     --refs `git symbolic-ref HEAD`
> 
> which yields output like:
> 
>   your-topic: network: Remove unused function
>   your-topic~1: session: Fix introspection for Change()
>   your-topic~2: wifi: Refactor desctruction of network object
>   your-topic~3: network: Remove device pointer in network_remove()

Didn't know about name-ref. Very cool :)

> However, if you really just want this to make "rebase -i" easier, have
> you considered setting the upstream branch config for your branches?
> When I create a topic branch, I do:

Maybe I should have mentioned that on those project I am mostly working,
we don't have branches (ConnMan, BlueZ, oFono). So we have a very simple
history.

>   git checkout -b topic origin/master
> 
> And then "git rebase -i @{upstream}" rebases everything up to my
> upstream branch (origin/master). That may be slightly more than I want,
> but it lets me see the whole series in the "rebase -i" sequencer. Recent
> versions of git even default to "@{upstream}", so you can just say "git rebase
> -i".

The main reason I avoided branches is that I have several topics at the
same time and having a single branch and maintaining them by hand was so
far easier.

> How do you usually create your branches? What version of git are you
> using (the "@{upstream}" default is in v1.7.6 and later)?

Normally I only have for big changes branches but for a few independent
fixed I just use the master branch and fix the patches. But I see, I
should over think my workflow here :)

I am using git trunk :) I'll try the @{upstream} trick.

Thanks a lot for this elaborate answer.

cheers,
daniel